SystemOrganization addCategory: #'XMLRPC-Server-Tests'!

TestCase subclass: #XMLRPCServerTest
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Tests'!

!XMLRPCServerTest methodsFor: 'running' stamp: 'LucFabresse 5/8/2015 18:31'!
setUp
	server := XMLRPCServerForTest new startOn: 8081! !

!XMLRPCServerTest methodsFor: 'running' stamp: 'LucFabresse 5/8/2015 18:31'!
tearDown
	server stop! !

!XMLRPCServerTest methodsFor: 'tests' stamp: 'LucFabresse 5/8/2015 18:32'!
testDictionary
	| d p r |
	d := Dictionary new.
	d at: 'true' put: true.
	d at: 'Markus' put: 'Fritsche'.
	p := XMLRPCProxy new url: 'http://localhost:8081/' asUrl.
	r := p invokeMethod: 'validator1.echoStructTest' withStruct: d.
	self assert: r = d! !

!XMLRPCServerTest methodsFor: 'tests' stamp: 'LucFabresse 5/8/2015 18:32'!
testHallo
	| p |
	p := XMLRPCProxy new url: 'http://localhost:8081/' asUrl.
	p invokeMethod: 'validator1.echoStructTest' withArgs: #('Hallo')
! !

!XMLRPCServerTest methodsFor: 'tests' stamp: 'LucFabresse 5/8/2015 18:43'!
testThroughClient
" bring in tests here independently in next version.. for now just reuse the XMLRPCTests"

 | client |
 client := XMLRPCClientTest suite.
 client run.
! !

Object subclass: #XMLRPCServerForTest
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XMLRPC-Server-Tests'!

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:28'!
arrayOfStructsTest: aCollection 
	| ret |
	ret := 0.
	aCollection first	do: [:each | ret := ret
								+ (each at: 'curly')].
	^ ret! !

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:28'!
countTheEntities: aCollection 
	| ret string |
	ret := Dictionary new.
	string := aCollection first.
	ret
		at: 'ctLeftAngleBrackets'
		put: (string occurrencesOf: $<).
	ret
		at: 'ctRightAngleBrackets'
		put: (string occurrencesOf: $>).
	ret
		at: 'ctAmpersands'
		put: (string occurrencesOf: $&).
	ret
		at: 'ctApostrophes'
		put: (string occurrencesOf: $').
	ret
		at: 'ctQuotes'
		put: (string occurrencesOf: $").
	^ ret! !

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:28'!
easyStructTest: aCollection
	| ret |
	ret := 0. aCollection first valuesDo: [ :each | ret := ret + each ].
	^ret! !

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:39'!
echo: aValue

   ^aValue! !

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:28'!
echoStructTest: aDictionary 

	^ aDictionary! !

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:28'!
manyTypesTest: aCollection
    "simply return the decoded values in aCollection encoded"
	| arr x | 
	x := 1.
	arr := Array new: 6.
	aCollection do: [ :each | arr at: x put: each. x := x+1].
	^arr ! !

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:28'!
moderateSizeArrayCheck: aCollection 
	| arr |
	arr := aCollection first.
	^ (arr first), (arr last)! !

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:28'!
nestedStructTest: aCollection
	| struct ret |
	struct := aCollection first.
	ret := 0.
	(((struct at: '2000') at: '04') at: '01') valuesDo: [ :each | ret := ret + each].
	^ ret! !

!XMLRPCServerForTest methodsFor: 'services' stamp: 'LucFabresse 5/9/2015 15:47'!
services
	^ {
		'validator1.arrayOfStructsTest' -> { self-> #arrayOfStructsTest:}.
		'validator1.countTheEntities'  ->  { self ->  #countTheEntities:}.
		'validator1.echoStructTest'  ->  { self ->  #echoStructTest:}.
		'validator1.easyStructTest'  ->  { self  ->  #easyStructTest:}.
		'validator1.moderateSizeArrayCheck'  ->  { self ->  #moderateSizeArrayCheck:}.
		'validator1.nestedStructTest'  ->  { self ->  #nestedStructTest:}.
		'validator1.simpleStructReturnTest'  ->  { self ->  #simpleStructReturnTest:}.
		'validator1.manyTypesTest'  ->  { self ->  #manyTypesTest: }.	
		'echo.echoArray' -> { self-> #echo:}.
		'echo.echoBinary' 	-> { self-> #echo: }. 
		'echo.echoBoolean' 	-> { self-> #echo: }. 
		'echo.echoDateTime' 	-> { self-> #echo: }. 
		'echo.echoDouble' 	-> { self-> #echo: }. 
		'echo.echoInt' 		-> { self-> #echo: }. 
		'echo.echoString' 	-> { self-> #echo: }. 
		'echo.echoStruct' 	-> { self-> #echo: }.
	} asXMLRPCHttpModule! !

!XMLRPCServerForTest methodsFor: 'services callbacks' stamp: 'LucFabresse 5/8/2015 18:28'!
simpleStructReturnTest: aCollection 
	| num dict |
	dict := Dictionary new.
	num := aCollection first.
	dict at: 'times10' put: num * 10;
		 at: 'times100' put: num * 100;
		 at: 'times1000' put: num * 1000.
	^ dict! !

!XMLRPCServerForTest methodsFor: 'running' stamp: 'LucFabresse 5/9/2015 15:32'!
start
	^ self startOn: 8081! !

!XMLRPCServerForTest methodsFor: 'running' stamp: 'LucFabresse 5/9/2015 15:46'!
startOn: aPortNumber
	server := XMLRPCServer startOn: aPortNumber with: self services 
	! !

!XMLRPCServerForTest methodsFor: 'running' stamp: 'LucFabresse 5/9/2015 15:40'!
stop
	server destroy
! !
